import { EntityDamageCause, EquipmentSlot, system } from "@minecraft/server";
import { afterEvents, beforeEvents } from "./libraries/utils";
import WoodConvertions from "./libraries/wood_convertions";
import { DamageItem } from "./modules/Durability";
afterEvents.playerBreakBlock.subscribe(({ player }) => DamageItem(player, EquipmentSlot.Mainhand));
const cooldown = new Map();
beforeEvents.itemUseOn.subscribe(({ source: player, itemStack: item, block }) => {
    const pos = JSON.stringify(block.location);
    if (!item.typeId.startsWith('true_ep:') || cooldown.has(pos))
        return;
    cooldown.set(pos, system.runTimeout(() => cooldown.delete(pos), 5));
    const id = block.typeId;
    const tags = block.getTags();
    system.run(() => {
        switch (item.typeId.split(':')[1]) {
            case 'emerald_hoe': {
                if (!tags.includes('grass') && !id.includes('dirt'))
                    return;
                player.playSound('step.gravel');
                break;
            }
            case 'emerald_axe': {
                if (!Object.keys(WoodConvertions).includes(id))
                    return;
                player.playSound('use.wood');
                break;
            }
            case 'emerald_shovel': {
                if (!tags.includes('fertilize_area'))
                    return;
                player.playSound('step.grass');
                break;
            }
            default: return;
        }
        DamageItem(player, EquipmentSlot.Mainhand);
    });
});
afterEvents.entityHurt.subscribe(({ damageSource: { cause, damagingEntity: player } }) => {
    if (!player?.isPlayer() || cause !== EntityDamageCause.entityAttack)
        return;
    DamageItem(player, EquipmentSlot.Mainhand);
});
