import { EntityDamageCause, EquipmentSlot, system } from "@minecraft/server";
import { Vector } from "../libraries/utils";
export function Combat({ hurtEntity: target, damageSource: { cause, damagingEntity: player } }) {
    if (!player?.isPlayer() || cause !== EntityDamageCause.entityAttack)
        return;
    const equippable = player.equippable;
    const item = equippable.getEquipment(EquipmentSlot.Mainhand);
    const count = (player.getDynamicProperty('thunder_sword') ?? 0) + 1;
    if (count < 3)
        return player.setDynamicProperty('thunder_sword', count);
    // player.addEffect('fire_resistance', 30, { showParticles: false });
    target.dimension.spawnEntity('minecraft:lightning_bolt', Vector.add(target.location, Vector.multiply({ ...player.getViewDirection(), y: 0 }, 1.2)));
    system.runTimeout(() => player.extinguishFire(false), 5);
    player.setDynamicProperty('thunder_sword', 0);
}
